# spacetower_data_management_python_client
This API is responsible for managing computations.


This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 0.1.0
- Generator version: 7.6.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import spacetower_data_management_python_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import spacetower_data_management_python_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import spacetower_data_management_python_client
from spacetower_data_management_python_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.exoops.exotrail.space/computations/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = spacetower_data_management_python_client.Configuration(
    host = "https://api.exoops.exotrail.space/computations/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure HTTP basic authorization: basicAuth
configuration = spacetower_data_management_python_client.Configuration(
    username = os.environ["USERNAME"],
    password = os.environ["PASSWORD"]
)


# Enter a context with an instance of the API client
with spacetower_data_management_python_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = spacetower_data_management_python_client.DefaultApi(api_client)
    id = 'id_example' # str | The computation ID

    try:
        # Cancel a computation
        api_instance.cancel_computation(id)
    except ApiException as e:
        print("Exception when calling DefaultApi->cancel_computation: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.exoops.exotrail.space/computations/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**cancel_computation**](docs/DefaultApi.md#cancel_computation) | **DELETE** /computations/{id} | Cancel a computation
*DefaultApi* | [**get_computation**](docs/DefaultApi.md#get_computation) | **GET** /computations/{id} | Find a computation by ID
*DefaultApi* | [**list_computations**](docs/DefaultApi.md#list_computations) | **GET** /computations | Return all computations
*DefaultApi* | [**trigger_computation**](docs/DefaultApi.md#trigger_computation) | **POST** /computations/{service}/{version}/{endpoint} | Trigger a new computation


## Documentation For Models

 - [Computation](docs/Computation.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="basicAuth"></a>
### basicAuth

- **Type**: HTTP basic authentication


## Author




